package com.izouma.nineth.web;
import com.izouma.nineth.domain.Follow;
import com.izouma.nineth.service.FollowService;
import com.izouma.nineth.dto.PageQuery;
import com.izouma.nineth.exception.BusinessException;
import com.izouma.nineth.repo.FollowRepo;
import com.izouma.nineth.utils.ObjUtils;
import com.izouma.nineth.utils.excel.ExcelUtils;
import lombok.AllArgsConstructor;
import org.springframework.data.domain.Page;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.List;

@RestController
@RequestMapping("/follow")
@AllArgsConstructor
public class FollowController extends BaseController {
    private FollowService followService;
    private FollowRepo followRepo;

    //@PreAuthorize("hasRole('ADMIN')")
    @PostMapping("/save")
    public Follow save(@RequestBody Follow record) {
        if (record.getId() != null) {
            Follow orig = followRepo.findById(record.getId()).orElseThrow(new BusinessException("无记录"));
            ObjUtils.merge(orig, record);
            return followRepo.save(orig);
        }
        return followRepo.save(record);
    }


    //@PreAuthorize("hasRole('ADMIN')")
    @PostMapping("/all")
    public Page<Follow> all(@RequestBody PageQuery pageQuery) {
        return followService.all(pageQuery);
    }

    @GetMapping("/get/{id}")
    public Follow get(@PathVariable Long id) {
        return followRepo.findById(id).orElseThrow(new BusinessException("无记录"));
    }

    @PostMapping("/del/{id}")
    public void del(@PathVariable Long id) {
        followRepo.softDelete(id);
    }

    @GetMapping("/excel")
    @ResponseBody
    public void excel(HttpServletResponse response, PageQuery pageQuery) throws IOException {
        List<Follow> data = all(pageQuery).getContent();
        ExcelUtils.export(response, data);
    }
}

